package probe

import (
	"context"
	"fmt"
	"sync"

	// For service
	_ "git.loafle.net/overflow/probe/service"
)

type Probe struct {
	stopChan chan struct{}
	stopWg   sync.WaitGroup
}

func (p *Probe) Start() error {
	if p.stopChan != nil {
		return fmt.Errorf("already running. Stop it before starting it again")
	}

	// services, err := cdr.GetInstancesByAnnotationType(occa.RPCServiceAnnotationType)
	// if nil != err {
	// 	return err
	// }

	// client, err := central.NewProbe(p.HandleEncryptionKey, services)
	// if nil != err {
	// 	return err
	// }

	p.stopChan = make(chan struct{})

	p.stopWg.Add(1)
	go p.handleProbe()

	return nil
}

func (p *Probe) Stop(ctx context.Context) error {
	if p.stopChan == nil {
		return fmt.Errorf("must be started before stopping it")
	}
	close(p.stopChan)
	p.stopWg.Wait()

	p.stopChan = nil

	return nil
}

func (p *Probe) logHeader() string {
	return "Probe:"
}

func (p *Probe) HandleEncryptionKey(encryptionKey string) {

}

func (p *Probe) handleProbe() {
	// var err error
	// defer func() {
	// 	if nil != client {
	// 		err = client.Stop(context.Background())
	// 	}

	// 	a.stopWg.Done()
	// 	endChan <- err
	// }()

	// if err = client.Start(); nil != err {
	// 	logging.Logger().Error(err)
	// 	return
	// }

	// for {
	// 	select {
	// 	case err = <-authDoneChan:
	// 		return
	// 	case <-a.stopChan:
	// 		return
	// 	}
	// }
}
